--- old/usr/src/lib/libm/common/m9x/__fex_sse.c	2014-05-04 03:06:18.139734559 +0200
+++ new/usr/src/lib/libm/common/m9x/__fex_sse.c	2014-05-04 03:06:18.169694625 +0200
@@ -243,7 +243,7 @@
 			    fp_reg_set.fpchip_state.xmm[r];
 		}
 	} else if ((modrm & 0xc7) == 0x05) {
-#if defined(__amd64)
+#ifdef __amd64
 		/* address of next instruction + offset */
 		r = i + 4;
 		if (inst->op == cmpss || inst->op == cmpps ||
@@ -262,7 +262,7 @@
 			sib = ip[i++];
 			if ((sib & 7) == 5 && (modrm >> 6) == 0) {
 				/* start with absolute address */
-				addr = (char *)(uintptr_t)(ip + i);
+				addr = (char *)(uintptr_t)(*(int *)(ip + i));
 				i += 4;
 			} else {
 				/* start with base */
@@ -370,6 +370,8 @@
 	case cvttss2siq:
 	case cvttsd2siq:
 		return fex_inv_int;
+	default:
+		break;
 	}
 
 	/* check op1 for signaling nan */
@@ -411,6 +413,8 @@
 			return fex_inv_zdz;
 		if (t1 == fp_infinity && t2 == fp_infinity)
 			return fex_inv_idi;
+	default:
+		break;
 	}
 
 	return (enum fex_exception)-1;
@@ -638,6 +642,8 @@
 			info->res.type = fex_nodata;
 			sse_comisd(&info->op1.val.d, &info->op2.val.d);
 			break;
+		default:
+			break;
 		}
 	} else {
 		if (inst->op == cvtsi2ss) {
@@ -791,6 +797,8 @@
 			info->res.type = fex_nodata;
 			sse_comiss(&info->op1.val.f, &info->op2.val.f);
 			break;
+		default:
+			break;
 		}
 	}
 	__fenv_getmxcsr(&mxcsr);
@@ -1083,6 +1091,8 @@
 			dummy.op2 = (sseoperand_t *)&inst->op2->d[i];
 			e[i] = __fex_get_sse_op(uap, &dummy, &info[i]);
 		}
+	default:
+		break;
 	}
 }
 
@@ -1098,10 +1108,10 @@
 __fex_st_sse_result(ucontext_t *uap, sseinst_t *inst, enum fex_exception e,
     fex_info_t *info)
 {
-	int		i;
-	long long	l;
-	float		f, fscl;
-	double		d, dscl;
+	int		i = 0;
+	long long	l = 0L;;
+	float		f = 0.0, fscl;
+	double		d = 0.0L, dscl;
 
 	/* for compares that write eflags, just set the flags
 	   to indicate "unordered" */
@@ -1228,6 +1238,9 @@
 		case fex_ldouble:
 			i = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->i[0] = i;
 	} else if (inst->op == cmpsd || inst->op == cvttss2siq ||
@@ -1253,6 +1266,9 @@
 		case fex_ldouble:
 			l = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->l[0] = l;
 	} else if ((((int)inst->op & DOUBLE) && inst->op != cvtsd2ss) ||
@@ -1277,6 +1293,9 @@
 		case fex_ldouble:
 			d = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->d[0] = d;
 	} else {
@@ -1300,6 +1319,9 @@
 		case fex_ldouble:
 			f = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->f[0] = f;
 	}
@@ -1578,5 +1600,9 @@
 		}
 		/* zero the high 64 bits of the destination */
 		inst->op1->l[1] = 0ll;
+
+	default:
+		break;
 	}
 }
+
